from PyPDF2 import PdfReader, PdfWriter
import os

def remove_last_page(file_name):
    # Get the full path of the PDF file
    script_dir = os.path.dirname(os.path.abspath(__file__))
    file_path = os.path.join(script_dir, file_name)

    # Check if the file exists
    if not os.path.exists(file_path):
        print(f"Error: The file '{file_name}' does not exist in the script's directory.")
        return

    # Open the PDF file
    with open(file_path, 'rb') as file:
        pdf_reader = PdfReader(file)
        pdf_writer = PdfWriter()

        # Get the total number of pages
        total_pages = len(pdf_reader.pages)

        # If the PDF has only one page or is empty, we can't remove the last page
        if total_pages <= 1:
            print("The PDF has one page or less. No changes made.")
            return

        # Add all pages except the last one to the writer
        for page_num in range(total_pages - 1):
            page = pdf_reader.pages[page_num]
            pdf_writer.add_page(page)

        # Write the modified PDF to the same file
        with open(file_path, 'wb') as output_file:
            pdf_writer.write(output_file)

    print(f"Last page removed from {file_name}")

if __name__ == "__main__":
    # Replace 'your_file.pdf' with the actual name of your PDF fil
    pdf_file_name = 'your_file.pdf'
    remove_last_page(pdf_file_name)